## source("C:/Users/mnunez/Downloads/z_repaso_indecis/cutting_month_mnc_nuts.R")

library(raster)
library(rasterVis)
library(sf)

print(paste0("Inicio: ",Sys.time()))

path0 <- "C:/Users/mnunez/Downloads/z_repaso_indecis/"
path1 <- paste0(path0,"input/")
path2 <- paste0(path0,"output/")

# index number:      01         02            03              04             05           06              07          08            09           10            11                12            13             14            15           16          17            18           19               20          21              22           23           24            25           26             27            28            29            30           31              32           33             34              35               36        37           38              39              40        41              42            43        44            45              46             47            48               49           50           51           52           53           54           55           56            57           58             59            60           61           62           63           64          65        66            67           68            69           70            71            72           73           74          75           76            77            78             79          80            81            82          83           84           85           86           87           88                       
indices = list("mni_month", "ffdi_month", "spi1_month", "tn10p_month", "xtn_month", "spei6_month", "d95p_month", "ssd_month", "cmd_month", "spei12_month", "rx1day_month", "sd0_10_month", "scd_month", "etr_month", "utci_month", "fd_month", "eto_month", "dr3mm_month", "r99tot_month", "csdi_month", "rx1d_month", "csd_month", "ntg_month", "ssp_month", "spi12_month", "fsd_month", "wsdi_month", "tx90p_month", "tn90p_month", "rx5d_month", "dtr_month", "dfx21_month", "r95tot_month", "hsd_month", "sd10_20_month", "msd_month", "gtn_month", "ogs10_month", "sdii_month", "wci_month", "rtwd_month", "gtg_month", "spei1_month", "id_month", "ntx_month", "fg6bft_month", "r20mm_month", "fgcalm_month", "snd_month", "r10mm_month", "dd_month", "fg_month", "fxx_month", "kbdi_month", "tx10p_month", "hd17_month", "mi_month", "stx32_month", "fwi_month", "ms_month", "dd17_month", "rti_month", "rt_month", "su_month", "ep_month", "tr_month", "d50mm_month", "dr1mm_month", "hi_month", "cwd_month", "vdtr_month", "vwd_month", "ss_month", "ntn_month", "gd4_month", "fffi_month", "spei3_month", "xtx_month", "vcd_month", "xtg_month", "d32_month", "fod_month", "uai_month", "zcd_month", "ogs6_month", "spi3_month", "spi6_month", "gtx_month")           

# lista de indices delimitada a los ejemplos: (GTX, R10mm, SPI12, FWI)
lista <- c(88,50,25,59)

# Bucle de indices
#for (m in 1:88) {   # bucle para todos los índices
for (m in lista) {   # bucle reducido

    # si no existe el subdirectorio de salida lo creamos    
    if (!file.exists(paste0(path2,indices[m]))) {
        dir.create(paste0(path2,indices[m]))
    }

    nc0 <- brick(paste0(path1,"raster/",indices[m],".nc"))
    print(paste0('abierto raster ',indices[m]))
    
    # CORRECCION DE NETCDF TRASPUESTOS Y GIRADOS #
    nc <- t(flip(flip(nc0, direction = 'y'),direction = 'x'))

    shp <- shapefile(paste0(path1,"shape/nuts"))
  
    # Bucle de nuts
    #for (i in 1:352)  {  # bucle para todos los nuts (poligonos)
    for (i in 252:252)  { # bucle para el nut EXTREMADURA ES43 
    
        provincias <- c(shp$FID)
        recorte <- crop(nc, shp[shp$FID == provincias[i],]) 
        recorte <- mask(recorte, shp[shp$FID == provincias[i],]) 
        print(paste0("poligono ",provincias[i]))  

        # Bucle de meses
        # for (j in 1:816) { # 816 months (68 años 1951 -2018)
        for (j in 613:733) { # 120 months (10 años) 2001-2010)
            print(paste0("mes ",j))
        
            date <- c(attributes(nc0)$z$Date)

            # geotiff
            filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".tif")
            filout
            writeRaster(subset(recorte, j), filename = filout, format = 'GTiff', overwrite = TRUE)
            
            # netcdf
            filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".nc")
            filout
            writeRaster(subset(recorte, j), filename = filout, format = 'netCDF', overwrite = TRUE)

            # Shapes
            mean <- extract(subset(recorte, j), shp[shp$FID == provincias[i],], mean, na.rm = FALSE, sp = TRUE)
            meanmax <- extract(subset(recorte, j), mean, max, na.rm = FALSE, sp = TRUE)
            meanmaxmin <- extract(subset(recorte, j), meanmax, min, na.rm = FALSE, sp = TRUE)
            names(meanmaxmin)[8] <- "mean"  # las componentes 8, 9 y 10 son porque el .dbf asociado al .shp ya tenía los campos (0 - 7)
            names(meanmaxmin)[9] <- "max"   # las componentes 8, 9 y 10 son porque el .dbf asociado al .shp ya tenía los campos (0 - 7)
            names(meanmaxmin)[10] <- "min"  # las componentes 8, 9 y 10 son porque el .dbf asociado al .shp ya tenía los campos (0 - 7)
            filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".shp")
            filout
            shapefile(meanmaxmin, filename = filout, overwrite = TRUE)

            # pdf
            pdf(paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".pdf"))
            plot(subset(recorte, j), ext = extent(shp[shp$ID == provincias[i],]),main = paste(indices[m],"-",gsub("[.]", "-", provincias[i]), date[j]))
            dev.off()

            # png
            png(paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".png"))
            plot(subset(recorte,j), ext = extent(shp[shp$ID == provincias[i],]),main = paste(indices[m],"-",gsub("[.]", "-", provincias[i]), date[j]))
            dev.off()
            rm(mean,meanmax,meanmaxmin)
        }
    }
}
print(paste0("Fin: ",Sys.time()))

