## source("C:/Users/mnunez/Downloads/z_repaso_indecis/cutting_season_mnc_nuts.R")

library(raster)
library(rasterVis)
library(sf)

print(paste0("Inicio: ",Sys.time()))

path0 <- "C:/Users/mnunez/Downloads/z_repaso_indecis/"
path1 <- paste0(path0,"input/")
path2 <- paste0(path0,"output/")

# index number:      01         02            03              04             05           06              07          08              09            10             11            12            13             14            15             16             17              18           19               20              21              22             23              24            25           26                27            28            29            30           31              32           33             34              35               36        37           38              39              40            41              42            43        44            45              46             47            48               49           50              51             52              53             54           55              56               57              58             59            60              61             62             63            64             65            66            67           68            69           70            71            72              73           74          75           76               77              78             79             80                      
indices = list("hi_season", "mni_season", "tx10p_season", "su_season", "dfx21_season", "gd4_season", "fxx_season", "gtn_season", "mi_season", "fgcalm_season", "zcd_season", "tr_season", "xtn_season", "stx32_season", "gtx_season", "rx5d_season", "r10mm_season", "ffdi_season", "ntx_season", "fg6bft_season", "sd0_10_season", "ep_season", "dr3mm_season", "ogs6_season", "ssp_season", "rx1day_season", "d32_season", "dtr_season", "gtg_season", "vcd_season", "fffi_season", "sdii_season", "scd_season", "cmd_season", "ssd_season", "rtwd_season", "xtx_season", "r20mm_season", "ms_season", "d50mm_season", "uai_season", "ss_season", "dd17_season", "kbdi_season", "tn90p_season", "ntg_season", "eto_season", "rx1d_season", "fg_season", "wsdi_season", "csdi_season", "tx90p_season", "vdtr_season", "wci_season", "msd_season", "sd10_20_season", "dr1mm_season", "cwd_season", "ogs10_season", "d95p_season", "fsd_season", "r95tot_season", "xtg_season", "hsd_season", "fwi_season", "dd_season", "hd17_season", "rti_season", "fod_season", "csd_season", "ntn_season", "fd_season", "id_season", "tn10p_season", "snd_season", "utci_season", "etr_season", "vwd_season", "r99tot_season", "rt_season")

# lista de indices delimitada a los ejemplos: (GTX, R10mm, FWI)
lista <- c(15,17,65)

# Bucle de indices
#for (m in 1:102) {     # bucle para todos los índices
for (m in lista) {      # bucle reducido

    # si no existe el subdirectorio de salida lo creamos    
    if (!file.exists(paste0(path2,indices[m]))) {
        dir.create(paste0(path2,indices[m]))
    }

    nc0 <- brick(paste0(path1,"raster/",indices[m],".nc"))
    print(paste0('abierto raster ',indices[m]))

    # CORRECCION DE NETCDF TRASPUESTOS Y GIRADOS #
    nc <- t(flip(flip(nc0, direction = 'y'),direction = 'x')) 

    shp <- shapefile(paste0(path1,"shape/nuts"))
    print('abiertos raster y shape')

    # Bucle de nuts
    #for (i in 1:352)  {    # bucle para todos los nuts (poligonos)
    for (i in 252:252)  {   # bucle para el nut EXTREMADURA ES43
    
        provincias <- c(shp$FID)
        recorte <- crop(nc, shp[shp$FID == provincias[i],]) 
        recorte <- mask(recorte, shp[shp$FID == provincias[i],]) 
        print(paste0("poligono-",provincias[i]))

        # bucle de estaciones-del-anho
        #for (j in 1:271) {     # 271 seasons (68 años 1951 - 2018)
        for (j in 205:244) {    #  40 seasons (10 años 2001 - 2010)

            date <- c(attributes(nc0)$z$Date)

            # geotiff
            filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".tif")
            filout
            writeRaster(subset(recorte, j), filename = filout, format = 'GTiff', overwrite = TRUE)

            # netcdf
            filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".nc")
            filout
            writeRaster(subset(recorte, j), filename = filout, format = 'netCDF', overwrite = TRUE)

            # Shapes
            mean <- extract(subset(recorte, j), shp[shp$FID == provincias[i],], mean, na.rm = FALSE, sp = TRUE)
            meanmax <- extract(subset(recorte, j), mean, max, na.rm = FALSE, sp = TRUE)
            meanmaxmin <- extract(subset(recorte, j), meanmax, min, na.rm = FALSE, sp = TRUE)
            names(meanmaxmin)[8] <- "mean"  # las componentes 8, 9 y 10 son porque el .dbf asociado al .shp ya tenía los campos (0 - 7)
            names(meanmaxmin)[9] <- "max"   # las componentes 8, 9 y 10 son porque el .dbf asociado al .shp ya tenía los campos (0 - 7)
            names(meanmaxmin)[10] <- "min"  # las componentes 8, 9 y 10 son porque el .dbf asociado al .shp ya tenía los campos (0 - 7)
            filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".shp")
            filout
            shapefile(meanmaxmin, filename = filout, overwrite = TRUE)

            # pdf
            pdf(paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".pdf"))
            plot(subset(recorte, j), ext = extent(shp[shp$ID == provincias[i],]),main = paste(indices[m],"-",gsub("[.]", "-", provincias[i]), date[j]))
            dev.off()

            # png
            png(paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".png"))
            plot(subset(recorte,j), ext = extent(shp[shp$ID == provincias[i],]),main = paste(indices[m],"-",gsub("[.]", "-", provincias[i]), date[j]))
            dev.off()

            rm(mean,meanmax,meanmaxmin)
        }
    }
}
print(paste0("Fin: ",Sys.time()))
