## source("C:/Users/mnunez/Downloads/z_repaso_indecis/cutting_year_mnc_europe.R")

library(raster)
library(rasterVis)
library(sf)

print(paste0("Inicio: ",Sys.time()))

path0 <- "C:/Users/mnunez/Downloads/z_repaso_indecis/"
path1 <- paste0(path0,"input/")
path2 <- paste0(path0,"output/")

# index number:      01         02            03          04        05         06           07          08         09           10         11          12            13          14         15          16          17           18          19           20          21          22           23           24            25           26         27          28          29            30         31           32          33         34          35           36           37           38            39           40        41              42            43        44            45          46             47            48         49           50           51           52           53           54           55           56          57         58          59           60          61          62           63           64          65        66            67           68            69           70          71            72           73           74          75           76            77            78           79          80          81          82          83         84           85           86           87           88          89           90           91           92          93            94            95             96           97           98        99         100        101           102                 
indices = list("pici_year", "scd_year", "dd17_year", "dtr_year", "hi_year", "ws_year", "ssd_year", "xtg_year", "ssp_year", "fsd_year", "fxx_year", "fpsc_year", "lpsc_year", "hsd_year", "tr_year", "cwd_year", "fsc_year", "ffdi_year", "koi_year", "ntn_year", "utci_year", "fwi_year", "r99tot_year", "stn10_year", "gd4_year", "ss_year", "gsr_year", "ntg_year", "hd17_year", "pci_year", "su_year", "rtwd_year", "csd_year", "vcd_year", "rti_year", "r10mm_year", "etr_year", "tx90p_year", "ta_o_year", "sdii_year", "kbdi_year", "tx10p_year", "xtx_year", "mni_year", "eai_year", "fffi_year", "sd10_20_year", "msd_year", "gtx_year", "csdi_year", "fg6bft_year", "dfx21_year", "fd_year", "wki_year", "ogs10_year", "gtn_year", "id_year", "fg_year", "wci_year", "tn10p_year", "moi_year", "mai_year", "tm_s_year", "cmd_year", "d32_year", "ep_year", "r95tot_year", "vwd_year", "stn15_year", "rx5d_year", "gsl_year", "dr1mm_year", "tn90p_year", "mi_year", "sd0_10_year", "rx1day_year", "ptg_year", "ntx_year", "d95p_year", "uai_year", "fod_year", "snd_year", "gtg_year", "dd_year", "vdtr_year", "xtn_year", "zcd_year", "dr3mm_year", "ogs6_year", "wsdi_year", "jci_year", "d50mm_year", "eto_year", "fgcalm_year", "r20mm_year", "stx32_year", "ngsr_year", "ms_year", "mfi_year", "rt_year", "rx1d_year", "snt15_year")     

# lista de indices delimitada a los ejemplos: (GTX, R10mm, FWI)
lista <- c(22,36,49)

# Bucle de indices 
#for (m in 1:102) { # bucle para todos los índices
for (m in lista) {  # bucle reducido para los índices ejemplo

    # si no existe el subdirectorio de salida lo creamos    
    if (!file.exists(paste0(path2,indices[m]))) {
        dir.create(paste0(path2,indices[m]))
    }

    nc0 <- brick(paste0(path1,"raster/",indices[m],".nc"))
    print(paste0('abierto raster ',indices[m]))

    # CORRECCION DE NETCDF TRASPUESTOS Y GIRADOS #
    nc <- t(flip(flip(nc0, direction = 'y'),direction = 'x')) 

    shp <- shapefile(paste0(path1,"shape/europa"))
    print('abiertos raster y shape')
  
    # Bucle de polígonos, hay que verla en el fichero europa.shp
    lista2 <- c(12,25,29)
    
    # Bucle de poligonos
    #for (i in 1:352)  {  # bucle total para el shape europa (352 poligonos)
    for (i in lista2)  {  # bucle reducido, de ejemplo, para los poligonos: SPAIN, PORTUGAL y FRANCE
    
            provincias <- c(shp$NAME)
            recorte <- crop(nc, shp[shp$NAME == provincias[i],]) 
            recorte <- mask(recorte, shp[shp$NAME == provincias[i],]) 
            print(paste0("poligono-",provincias[i]))

            # Bucle de anhos
            #for (j in 1:68) { # 68 years (1951 - 2018)
            for (j in 52:61) { # 10 years (2001 - 2010)
      
                date <- c(attributes(nc0)$z$Date)

                # geotiff
                filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".tif")
                filout
                writeRaster(subset(recorte, j), filename = filout, format = 'GTiff', overwrite = TRUE)

                # netcdf
                filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".nc")
                filout
                writeRaster(subset(recorte, j), filename = filout, format = 'netCDF', overwrite = TRUE)

                # Shapes
                print('entro')
                mean <- extract(subset(recorte, j), shp[shp$NAME == provincias[i],], mean, na.rm = FALSE, sp = TRUE)
                print('entro2')
                meanmax <- extract(subset(recorte, j), mean, max, na.rm = FALSE, sp = TRUE)
                meanmaxmin <- extract(subset(recorte, j), meanmax, min, na.rm = FALSE, sp = TRUE)
                print('entro3')
                names(meanmaxmin)[3] <- "mean"  # las componentes 3, 4 y 5 son porque el .dbf asociado al .shp ya tenía los campos (0 - 2)
                names(meanmaxmin)[4] <- "max"   # las componentes 3, 4 y 5 son porque el .dbf asociado al .shp ya tenía los campos (0 - 2)
                names(meanmaxmin)[5] <- "min"   # las componentes 3, 4 y 5 son porque el .dbf asociado al .shp ya tenía los campos (0 - 2)
                filout = paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".shp")
                print(filout)
                shapefile(meanmaxmin, filename = filout, overwrite = TRUE)
                print('salgo')
                
                # pdf
                pdf(paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".pdf"))
                plot(subset(recorte, j), ext = extent(shp[shp$ID == provincias[i],]),main = paste(indices[m],"-",gsub("[.]", "-", provincias[i]), date[j]))
                dev.off()

                # png
                png(paste0(path2,indices[m],"/",indices[m],"-",gsub("[.]", "-", provincias[i]),"-", date[j],".png"))
                plot(subset(recorte,j), ext = extent(shp[shp$ID == provincias[i],]),main = paste(indices[m],"-",gsub("[.]", "-", provincias[i]), date[j]))
                dev.off()
                rm(mean,meanmax,meanmaxmin)
            }
    }
}
print(paste0("Fin: ",Sys.time()))


